？<template>
    <layout-form>
        <el-form :model="form" :loading="loading" :rules="rules" size='small' style="width:100%" label-width='120px' ref="form">
            <el-row>
            <#list columns as column>
                <#if column.isPrimaryKey != 1>
                    <#if column.htmlType == 1 && !column.columnType?contains("tinyint")>
                        <Field label="${column.columnComment}" prop="${column.javaField}" v-model="form.${column.javaField}" placeholder="请输入${column.columnComment}"/>
                    <#elseif column.htmlType == 2>
                        <Field label="${column.columnComment}" prop="${column.javaField}" v-model="form.${column.javaField}" type="textarea" placeholder="请输入${column.columnComment}"/>
                    <#elseif column.htmlType == 3 ||column.columnType?contains("tinyint")>
                        <Field label="${column.columnComment}" prop="${column.javaField}" v-model="form.${column.javaField}" type="select" :enumData="dict.${column.javaField}" placeholder="请选择${column.columnComment}"/>
                    <#elseif column.htmlType == 4>
                        <Field label="${column.columnComment}" prop="${column.javaField}" v-model="form.${column.javaField}" type="checkbox" :enumData="dict.${column.javaField}" />
                    <#elseif column.htmlType == 5>
                        <Field label="${column.columnComment}" prop="${column.javaField}" v-model="form.${column.javaField}" type="radio" :enumData="dict.${column.javaField}" />
                    <#elseif column.htmlType == 6>
                        <Field label="${column.columnComment}" prop="${column.javaField}" v-model="form.${column.javaField}" type="date" :enumData="dict.${column.javaField}" />
                    <#elseif column.htmlType == 6>
                        <Field label="${column.columnComment}" prop="${column.javaField}" v-model="form.${column.javaField}" type="date" :enumData="dict.${column.javaField}" />
                    <#else >
                        <Field label="${column.columnComment}" prop="${column.javaField}" v-model="form.${column.javaField}" placeholder="请输入${column.columnComment}"/>
                    </#if>
                </#if>
            </#list>
            </el-row>
            <form-buttons @submit='submitForm'/>
        </el-form>
    </layout-form>
</template>

<script>
    import form from "@/assets/mixins/form";
    export default {
        mixins: [form],
        toString:[
            <#list columns as column>
            <#if column.columnType?contains("tinyint")>
            "${column.javaField}",
            </#if>
            </#list>
        ],
        data() {
            return {
                rules: {
                    <#list columns as column>
                    <#if column.javaType == "String" && column.isEdit==1>
                    ${column.javaField}: [
                        {<#if column.isRequired==1>required: true,</#if> trigger: "blur" },
                    ],
                    </#if>
                    <#if column.javaType == "Integer" && column.isEdit==1>
                    ${column.javaField}: [
                        {<#if column.isRequired==1>required: true,</#if> type: 'integer',trigger: "blur" },
                    ],
                    </#if>
                    <#if column.javaType == "BigDecimal" && column.isEdit==1>
                    ${column.javaField}: [
                        {<#if column.isRequired==1>required: true,</#if> type: 'number',trigger: "blur" },
                    ],
                    </#if>
                    <#if column.javaType == "Date" &&column.htmlType ==6 && column.isEdit==1>
                    ${column.javaField}: [
                        {<#if column.isRequired==1>required: true,</#if> },
                    ],
                    </#if>
                    </#list>
                }
            };
        }
    };
</script>