<template>
    <div class="page">
        <LayoutTable :data='tableData' :config='tableConfig' />
    </div>
</template>

<script>
    import table from "@/assets/mixins/table";

    export default {
        components: {
        },
        mixins: [table],
        created() {
        },
        methods: {
        },
        data() {
            return {
                config: {
                    search: [

                    ],
                    columns: [
                        {type: "selection", width: 60},
                        <#list fields as field>
                        <#if field.typeName == "java.lang.Long">
                        {label: "${field.sourceFieldName}", prop: "${field.attName}", formatter: this.formatterString},
                        </#if>
                        <#if field.typeName == "String"||field.typeName == "java.lang.Integer">
                        {label: "${field.sourceFieldName}", prop: "${field.attName}"},
                        </#if>
                        <#if field.typeName == "java.util.Date">
                        {label: "${field.sourceFieldName}", prop: "${field.attName}", formatter: this.formatterDate},
                        </#if>
                        <#if field.typeName == "BigDecimal">
                        {label: "${field.sourceFieldName}", prop: "${field.attName}", formatter: this.formatterMoney},
                        </#if>
                        </#list>
                        {
                            label: "操作",
                            width: 180,
                            formatter: row => {
                                return (
                                    <div><el-button type="primary" icon="el-icon-edit" round size='mini' onClick={()=>{this.toEdit(row)}}>编辑</el-button></div>
                            );
                            }
                        }
                    ]
                }
            };
        }
    };
</script>