？<template>
    <layout-form>
        <el-form :model="form" :loading="loading" :rules="rules" size='small' style="width:100%" label-width='120px' ref="form">
            <el-row>
            <#list fields as field>
                <#if field.columnName != "id">
                <Field label="${field.sourceFieldName}" prop="${field.columnName}" v-model="form.${field.columnName}" placeholder="请输入${field.sourceFieldName}"/>
                </#if>
            </#list>
            </el-row>
            <form-buttons @submit='submitForm'/>
        </el-form>
    </layout-form>
</template>

<script>
    import form from "@/assets/mixins/form";
    export default {
        mixins: [form],
        data() {
            return {
                rules: {
                    <#list fields as field>
                    <#if field.typeName == "String">
                    ${field.columnName}:[${field.isNotNull}
                        {max: ${field.sourceTypeVal}, message: '最多只能录入${field.sourceTypeVal}个字符', trigger: 'blur'}],
                    </#if>
                    <#if field.typeName == "java.lang.Integer">
                    ${field.attName}:[${field.isNotNull}{type: 'integer', trigger: 'blur'}],
                    </#if>
                    <#if field.typeName == "BigDecimal">
                    ${field.attName}:[${field.isNotNull}{type: 'number', trigger: 'blur'}],
                    </#if>
                    <#if field.typeName == "java.util.Date">
                    ${field.attName}:[${field.isNotNull}],
                    </#if>
                    </#list>
                }
            };
        }
    };
</script>